diff --git a/usr/src/uts/common/io/cxgbe/t4nex/t4_sge.c b/usr/src/uts/common/io/cxgbe/t4nex/t4_sge.c
index 7ca2bfe8a5..06d0e3f6d5 100644
--- a/usr/src/uts/common/io/cxgbe/t4nex/t4_sge.c
+++ b/usr/src/uts/common/io/cxgbe/t4nex/t4_sge.c
@@ -2523,8 +2523,8 @@ csum_to_ctrl(const struct txinfo *txinfo, uint32_t chip_version,
 {
 	const mac_ether_offload_info_t *meoi = &txinfo->meoi;
 	const uint32_t tx_flags = txinfo->flags;
-	const boolean_t needs_l3_csum = (tx_flags & HW_LSO) != 0 ||
-	    (tx_flags & HCK_IPV4_HDRCKSUM) != 0;
+	const boolean_t needs_l3_csum = ((tx_flags & HW_LSO) != 0 || (tx_flags &
+	    HCK_IPV4_HDRCKSUM) != 0) && meoi->meoi_l3proto == ETHERTYPE_IP;
 	const boolean_t needs_l4_csum = (tx_flags & HW_LSO) != 0 ||
 	    (tx_flags & (HCK_FULLCKSUM | HCK_PARTIALCKSUM)) != 0;
 
@@ -2541,8 +2541,7 @@ csum_to_ctrl(const struct txinfo *txinfo, uint32_t chip_version,
 
 	if (needs_l3_csum) {
 		/* Only IPv4 checksums are supported (for L3) */
-		if ((meoi->meoi_flags & MEOI_L3INFO_SET) == 0 ||
-		    meoi->meoi_l3proto != ETHERTYPE_IP) {
+		if ((meoi->meoi_flags & MEOI_L3INFO_SET) == 0) {
 			*ctrlp = ctrl;
 			return (COS_FAIL);
 		}
diff --git a/usr/src/uts/common/io/dld/dld_proto.c b/usr/src/uts/common/io/dld/dld_proto.c
index 0d1eb314dc..7ee13ed77a 100644
--- a/usr/src/uts/common/io/dld/dld_proto.c
+++ b/usr/src/uts/common/io/dld/dld_proto.c
@@ -22,6 +22,7 @@
  * Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright 2012, Nexenta Systems, Inc. All rights reserved.
  * Copyright (c) 2018, Joyent, Inc.
+ * Copyright 2025 Oxide Computer Company
  */
 
 /*
@@ -1420,7 +1421,8 @@ dld_capab_poll_enable(dld_str_t *dsp, dld_capab_poll_t *poll)
 	 * (IP) to directly poll the soft ring (since DLS processing
 	 * hasn't been done) nor can we allow DLS bypass.
 	 */
-	if (!mac_rx_bypass_set(dsp->ds_mch, dsp->ds_rx, dsp->ds_rx_arg))
+	if (!mac_rx_bypass_set(dsp->ds_mch, dsp->ds_rx, dsp->ds_rx_arg,
+	    dsp->ds_sap == ETHERTYPE_IPV6))
 		return (ENOTSUP);
 
 	/*
@@ -1541,18 +1543,10 @@ dld_capab(dld_str_t *dsp, uint_t type, void *data, uint_t flags)
 
 	switch (type) {
 	case DLD_CAPAB_DIRECT:
-		if (dsp->ds_sap == ETHERTYPE_IPV6) {
-			err = ENOTSUP;
-			break;
-		}
 		err = dld_capab_direct(dsp, data, flags);
 		break;
 
 	case DLD_CAPAB_POLL:
-		if (dsp->ds_sap == ETHERTYPE_IPV6) {
-			err = ENOTSUP;
-			break;
-		}
 		err =  dld_capab_poll(dsp, data, flags);
 		break;
 
diff --git a/usr/src/uts/common/io/mac/mac_client.c b/usr/src/uts/common/io/mac/mac_client.c
index 94ad441a65..2577942ce9 100644
--- a/usr/src/uts/common/io/mac/mac_client.c
+++ b/usr/src/uts/common/io/mac/mac_client.c
@@ -24,6 +24,7 @@
  * Copyright 2019 Joyent, Inc.
  * Copyright 2017 RackTop Systems.
  * Copyright 2022 OmniOS Community Edition (OmniOSce) Association.
+ * Copyright 2025 Oxide Computer Company
  */
 
 /*
@@ -1363,8 +1364,10 @@ mac_client_open(mac_handle_t mh, mac_client_handle_t *mchp, char *name,
 	mcip->mci_rx_p_fn = NULL;
 	mcip->mci_rx_p_arg = NULL;
 	mcip->mci_p_unicast_list = NULL;
-	mcip->mci_direct_rx_fn = NULL;
-	mcip->mci_direct_rx_arg = NULL;
+	mcip->mci_direct_rx.mdrx_v4 = NULL;
+	mcip->mci_direct_rx.mdrx_v6 = NULL;
+	mcip->mci_direct_rx.mdrx_arg_v4 = NULL;
+	mcip->mci_direct_rx.mdrx_arg_v6 = NULL;
 	mcip->mci_vidcache = MCIP_VIDCACHE_INVALID;
 
 	mcip->mci_unicast_list = NULL;
@@ -1549,7 +1552,8 @@ mac_client_close(mac_client_handle_t mch, uint16_t flags)
  * B_FALSE if it's not possible to enable bypass.
  */
 boolean_t
-mac_rx_bypass_set(mac_client_handle_t mch, mac_direct_rx_t rx_fn, void *arg1)
+mac_rx_bypass_set(mac_client_handle_t mch, mac_direct_rx_t rx_fn, void *arg1,
+    boolean_t v6)
 {
 	mac_client_impl_t	*mcip = (mac_client_impl_t *)mch;
 	mac_impl_t		*mip = mcip->mci_mip;
@@ -1568,8 +1572,13 @@ mac_rx_bypass_set(mac_client_handle_t mch, mac_direct_rx_t rx_fn, void *arg1)
 	 * These are not accessed directly in the data path, and hence
 	 * don't need any protection
 	 */
-	mcip->mci_direct_rx_fn = rx_fn;
-	mcip->mci_direct_rx_arg = arg1;
+	if (v6) {
+		mcip->mci_direct_rx.mdrx_v6 = rx_fn;
+		mcip->mci_direct_rx.mdrx_arg_v6 = arg1;
+	} else {
+		mcip->mci_direct_rx.mdrx_v4 = rx_fn;
+		mcip->mci_direct_rx.mdrx_arg_v4 = arg1;
+	}
 	return (B_TRUE);
 }
 
@@ -4331,21 +4340,7 @@ i_mac_capab_get(mac_handle_t mh, mac_capab_t cap, void *cap_data)
 	if (mip->mi_bridge_link != NULL) {
 		return (cap == MAC_CAPAB_NO_ZCOPY);
 	} else if (mip->mi_callbacks->mc_callbacks & MC_GETCAPAB) {
-		boolean_t res;
-
-		res = mip->mi_getcapab(mip->mi_driver, cap, cap_data);
-		/*
-		 * Until we have suppport for TSOv6 emulation in the MAC
-		 * loopback path, do not allow the TSOv6 capability to be
-		 * advertised to consumers.
-		 */
-		if (res && cap == MAC_CAPAB_LSO) {
-			mac_capab_lso_t *cap_lso = cap_data;
-
-			cap_lso->lso_flags &= ~LSO_TX_BASIC_TCP_IPV6;
-			cap_lso->lso_basic_tcp_ipv6.lso_max = 0;
-		}
-		return (res);
+		return (mip->mi_getcapab(mip->mi_driver, cap, cap_data));
 	} else {
 		return (B_FALSE);
 	}
diff --git a/usr/src/uts/common/io/mac/mac_datapath_setup.c b/usr/src/uts/common/io/mac/mac_datapath_setup.c
index 0da404853c..151942451f 100644
--- a/usr/src/uts/common/io/mac/mac_datapath_setup.c
+++ b/usr/src/uts/common/io/mac/mac_datapath_setup.c
@@ -22,6 +22,7 @@
  * Copyright (c) 2008, 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright 2018 Joyent, Inc.
  * Copyright 2020 RackTop Systems.
+ * Copyright 2025 Oxide Computer Company
  */
 
 #include <sys/types.h>
@@ -395,15 +396,29 @@ mac_srs_client_poll_enable(mac_client_impl_t *mcip,
 
 	softring = mac_srs->srs_soft_ring_head;
 	while (softring != NULL) {
-		if (softring->s_ring_type & (ST_RING_TCP | ST_RING_UDP)) {
+		if (mcip->mci_direct_rx.mdrx_v4 != NULL &&
+		    softring->s_ring_type & (ST_RING_TCP | ST_RING_UDP)) {
 			/*
 			 * TCP and UDP support DLS bypass. Squeue polling
 			 * support implies DLS bypass since the squeue poll
 			 * path does not have DLS processing.
 			 */
 			mac_soft_ring_dls_bypass(softring,
-			    mcip->mci_direct_rx_fn, mcip->mci_direct_rx_arg);
+			    mcip->mci_direct_rx.mdrx_v4,
+			    mcip->mci_direct_rx.mdrx_arg_v4);
 		}
+		if (mcip->mci_direct_rx.mdrx_v6 != NULL &&
+		    softring->s_ring_type & (ST_RING_TCP6 | ST_RING_UDP6)) {
+			/*
+			 * TCP and UDP support DLS bypass. Squeue polling
+			 * support implies DLS bypass since the squeue poll
+			 * path does not have DLS processing.
+			 */
+			mac_soft_ring_dls_bypass(softring,
+			    mcip->mci_direct_rx.mdrx_v6,
+			    mcip->mci_direct_rx.mdrx_arg_v6);
+		}
+
 		/*
 		 * Non-TCP protocols don't support squeues. Hence we don't
 		 * make any ring addition callbacks for non-TCP rings
@@ -1207,9 +1222,15 @@ mac_srs_fanout_list_alloc(mac_soft_ring_set_t *mac_srs)
 		mac_srs->srs_tcp_soft_rings = (mac_soft_ring_t **)
 		    kmem_zalloc(sizeof (mac_soft_ring_t *) * MAX_SR_FANOUT,
 		    KM_SLEEP);
+		mac_srs->srs_tcp6_soft_rings = (mac_soft_ring_t **)
+		    kmem_zalloc(sizeof (mac_soft_ring_t *) * MAX_SR_FANOUT,
+		    KM_SLEEP);
 		mac_srs->srs_udp_soft_rings = (mac_soft_ring_t **)
 		    kmem_zalloc(sizeof (mac_soft_ring_t *) * MAX_SR_FANOUT,
 		    KM_SLEEP);
+		mac_srs->srs_udp6_soft_rings = (mac_soft_ring_t **)
+		    kmem_zalloc(sizeof (mac_soft_ring_t *) * MAX_SR_FANOUT,
+		    KM_SLEEP);
 		mac_srs->srs_oth_soft_rings = (mac_soft_ring_t **)
 		    kmem_zalloc(sizeof (mac_soft_ring_t *) * MAX_SR_FANOUT,
 		    KM_SLEEP);
@@ -1668,7 +1689,9 @@ mac_client_update_classifier(mac_client_impl_t *mcip, boolean_t enable)
 static void
 mac_srs_update_fanout_list(mac_soft_ring_set_t *mac_srs)
 {
-	int tcp_count = 0, udp_count = 0, oth_count = 0, tx_count = 0;
+	int tcp_count = 0, tcp6_count = 0, udp_count = 0, udp6_count = 0,
+	    oth_count = 0, tx_count = 0;
+
 	mac_soft_ring_t *softring;
 
 	softring = mac_srs->srs_soft_ring_head;
@@ -1676,6 +1699,8 @@ mac_srs_update_fanout_list(mac_soft_ring_set_t *mac_srs)
 		ASSERT(mac_srs->srs_soft_ring_count == 0);
 		mac_srs->srs_tcp_ring_count = 0;
 		mac_srs->srs_udp_ring_count = 0;
+		mac_srs->srs_tcp6_ring_count = 0;
+		mac_srs->srs_udp6_ring_count = 0;
 		mac_srs->srs_oth_ring_count = 0;
 		mac_srs->srs_tx_ring_count = 0;
 		return;
@@ -1684,8 +1709,12 @@ mac_srs_update_fanout_list(mac_soft_ring_set_t *mac_srs)
 	while (softring != NULL) {
 		if (softring->s_ring_type & ST_RING_TCP) {
 			mac_srs->srs_tcp_soft_rings[tcp_count++] = softring;
+		} else if (softring->s_ring_type & ST_RING_TCP6) {
+			mac_srs->srs_tcp6_soft_rings[tcp6_count++] = softring;
 		} else if (softring->s_ring_type & ST_RING_UDP) {
 			mac_srs->srs_udp_soft_rings[udp_count++] = softring;
+		} else if (softring->s_ring_type & ST_RING_UDP6) {
+			mac_srs->srs_udp6_soft_rings[udp6_count++] = softring;
 		} else if (softring->s_ring_type & ST_RING_OTH) {
 			mac_srs->srs_oth_soft_rings[oth_count++] = softring;
 		} else {
@@ -1695,10 +1724,12 @@ mac_srs_update_fanout_list(mac_soft_ring_set_t *mac_srs)
 		softring = softring->s_ring_next;
 	}
 
-	ASSERT(mac_srs->srs_soft_ring_count ==
-	    (tcp_count + udp_count + oth_count + tx_count));
+	ASSERT(mac_srs->srs_soft_ring_count == (tcp_count + tcp6_count +
+	    udp_count + udp6_count + oth_count + tx_count));
 	mac_srs->srs_tcp_ring_count = tcp_count;
+	mac_srs->srs_tcp6_ring_count = tcp6_count;
 	mac_srs->srs_udp_ring_count = udp_count;
+	mac_srs->srs_udp6_ring_count = udp6_count;
 	mac_srs->srs_oth_ring_count = oth_count;
 	mac_srs->srs_tx_ring_count = tx_count;
 }
@@ -1728,10 +1759,11 @@ mac_srs_create_proto_softrings(int id, uint16_t type, pri_t pri,
 	 * TCP and UDP support DLS bypass. In addition TCP
 	 * squeue can also poll their corresponding soft rings.
 	 */
-	if (set_bypass && (mcip->mci_resource_arg != NULL)) {
+	if (set_bypass && mcip->mci_direct_rx.mdrx_v4 != NULL &&
+	    (mcip->mci_resource_arg != NULL)) {
 		mac_soft_ring_dls_bypass(softring,
-		    mcip->mci_direct_rx_fn,
-		    mcip->mci_direct_rx_arg);
+		    mcip->mci_direct_rx.mdrx_v4,
+		    mcip->mci_direct_rx.mdrx_arg_v4);
 
 		mrf.mrf_rx_arg = softring;
 		mrf.mrf_intr_handle = (mac_intr_handle_t)softring;
@@ -1759,13 +1791,47 @@ mac_srs_create_proto_softrings(int id, uint16_t type, pri_t pri,
 	    cpuid, rx_func, x_arg1, x_arg2);
 	softring->s_ring_rx_arg2 = NULL;
 
-	if (set_bypass && (mcip->mci_resource_arg != NULL)) {
+	if (set_bypass && mcip->mci_direct_rx.mdrx_v4 != NULL &&
+	    (mcip->mci_resource_arg != NULL)) {
+		mac_soft_ring_dls_bypass(softring,
+		    mcip->mci_direct_rx.mdrx_v4,
+		    mcip->mci_direct_rx.mdrx_arg_v4);
+	}
+
+	/* TCP for IPv6. */
+	softring = mac_soft_ring_create(id, mac_soft_ring_worker_wait,
+	    (type|ST_RING_TCP6), pri, mcip, mac_srs,
+	    cpuid, rx_func, x_arg1, x_arg2);
+	softring->s_ring_rx_arg2 = NULL;
+
+	if (set_bypass && mcip->mci_direct_rx.mdrx_v6 != NULL &&
+	    (mcip->mci_resource_arg != NULL)) {
+		mac_soft_ring_dls_bypass(softring,
+		    mcip->mci_direct_rx.mdrx_v6,
+		    mcip->mci_direct_rx.mdrx_arg_v6);
+
+		mrf.mrf_rx_arg = softring;
+		mrf.mrf_intr_handle = (mac_intr_handle_t)softring;
+
+		softring->s_ring_rx_arg2 =
+		    mcip->mci_resource_add((void *)mcip->mci_resource_arg,
+		    (mac_resource_t *)&mrf);
+	}
+
+	/* UDP for IPv6. */
+	softring = mac_soft_ring_create(id, mac_soft_ring_worker_wait,
+	    (type|ST_RING_UDP6), pri, mcip, mac_srs,
+	    cpuid, rx_func, x_arg1, x_arg2);
+	softring->s_ring_rx_arg2 = NULL;
+
+	if (set_bypass && mcip->mci_direct_rx.mdrx_v6 != NULL &&
+	    (mcip->mci_resource_arg != NULL)) {
 		mac_soft_ring_dls_bypass(softring,
-		    mcip->mci_direct_rx_fn,
-		    mcip->mci_direct_rx_arg);
+		    mcip->mci_direct_rx.mdrx_v6,
+		    mcip->mci_direct_rx.mdrx_arg_v6);
 	}
 
-	/* Create the Oth softrings which has to go through the DLS */
+	/* Create the Oth softrings which has to go through the DLS. */
 	softring = mac_soft_ring_create(id, mac_soft_ring_worker_wait,
 	    (type|ST_RING_OTH), pri, mcip, mac_srs,
 	    cpuid, rx_func, x_arg1, x_arg2);
@@ -1840,10 +1906,20 @@ mac_srs_fanout_modify(mac_client_impl_t *mcip, mac_direct_rx_t rx_func,
 				    (void *)mcip->mci_resource_arg,
 				    softring->s_ring_rx_arg2);
 			}
+			softring = mac_rx_srs->srs_tcp6_soft_rings[i];
+			if (softring->s_ring_rx_arg2 != NULL) {
+				mcip->mci_resource_remove(
+				    (void *)mcip->mci_resource_arg,
+				    softring->s_ring_rx_arg2);
+			}
 			mac_soft_ring_remove(mac_rx_srs,
 			    mac_rx_srs->srs_tcp_soft_rings[i]);
+			mac_soft_ring_remove(mac_rx_srs,
+			    mac_rx_srs->srs_tcp6_soft_rings[i]);
 			mac_soft_ring_remove(mac_rx_srs,
 			    mac_rx_srs->srs_udp_soft_rings[i]);
+			mac_soft_ring_remove(mac_rx_srs,
+			    mac_rx_srs->srs_udp6_soft_rings[i]);
 			mac_soft_ring_remove(mac_rx_srs,
 			    mac_rx_srs->srs_oth_soft_rings[i]);
 		}
@@ -1856,15 +1932,24 @@ mac_srs_fanout_modify(mac_client_impl_t *mcip, mac_direct_rx_t rx_func,
 		cpuid = srs_cpu->mc_rx_fanout_cpus[i];
 		(void) mac_soft_ring_bind(mac_rx_srs->srs_udp_soft_rings[i],
 		    cpuid);
+		(void) mac_soft_ring_bind(mac_rx_srs->srs_udp6_soft_rings[i],
+		    cpuid);
 		(void) mac_soft_ring_bind(mac_rx_srs->srs_oth_soft_rings[i],
 		    cpuid);
 		(void) mac_soft_ring_bind(mac_rx_srs->srs_tcp_soft_rings[i],
 		    cpuid);
+		(void) mac_soft_ring_bind(mac_rx_srs->srs_tcp6_soft_rings[i],
+		    cpuid);
 		softring = mac_rx_srs->srs_tcp_soft_rings[i];
 		if (softring->s_ring_rx_arg2 != NULL) {
 			mcip->mci_resource_bind((void *)mcip->mci_resource_arg,
 			    softring->s_ring_rx_arg2, cpuid);
 		}
+		softring = mac_rx_srs->srs_tcp6_soft_rings[i];
+		if (softring->s_ring_rx_arg2 != NULL) {
+			mcip->mci_resource_bind((void *)mcip->mci_resource_arg,
+			    softring->s_ring_rx_arg2, cpuid);
+		}
 	}
 
 	mac_srs_worker_bind(mac_rx_srs, srs_cpu->mc_rx_workerid);
@@ -3420,6 +3505,8 @@ mac_srs_fanout_list_free(mac_soft_ring_set_t *mac_srs)
 
 		ASSERT(mac_srs->srs_tcp_soft_rings == NULL);
 		ASSERT(mac_srs->srs_udp_soft_rings == NULL);
+		ASSERT(mac_srs->srs_tcp6_soft_rings == NULL);
+		ASSERT(mac_srs->srs_udp6_soft_rings == NULL);
 		ASSERT(mac_srs->srs_oth_soft_rings == NULL);
 		ASSERT(mac_srs->srs_tx_soft_rings != NULL);
 		kmem_free(mac_srs->srs_tx_soft_rings,
@@ -3432,14 +3519,27 @@ mac_srs_fanout_list_free(mac_soft_ring_set_t *mac_srs)
 		}
 	} else {
 		ASSERT(mac_srs->srs_tx_soft_rings == NULL);
+
 		ASSERT(mac_srs->srs_tcp_soft_rings != NULL);
 		kmem_free(mac_srs->srs_tcp_soft_rings,
 		    sizeof (mac_soft_ring_t *) * MAX_SR_FANOUT);
 		mac_srs->srs_tcp_soft_rings = NULL;
+
 		ASSERT(mac_srs->srs_udp_soft_rings != NULL);
 		kmem_free(mac_srs->srs_udp_soft_rings,
 		    sizeof (mac_soft_ring_t *) * MAX_SR_FANOUT);
 		mac_srs->srs_udp_soft_rings = NULL;
+
+		ASSERT(mac_srs->srs_tcp6_soft_rings != NULL);
+		kmem_free(mac_srs->srs_tcp6_soft_rings,
+		    sizeof (mac_soft_ring_t *) * MAX_SR_FANOUT);
+		mac_srs->srs_tcp6_soft_rings = NULL;
+
+		ASSERT(mac_srs->srs_udp6_soft_rings != NULL);
+		kmem_free(mac_srs->srs_udp6_soft_rings,
+		    sizeof (mac_soft_ring_t *) * MAX_SR_FANOUT);
+		mac_srs->srs_udp6_soft_rings = NULL;
+
 		ASSERT(mac_srs->srs_oth_soft_rings != NULL);
 		kmem_free(mac_srs->srs_oth_soft_rings,
 		    sizeof (mac_soft_ring_t *) * MAX_SR_FANOUT);
diff --git a/usr/src/uts/common/io/mac/mac_ktest.c b/usr/src/uts/common/io/mac/mac_ktest.c
index 7cc54d35d8..0ee4820c30 100644
--- a/usr/src/uts/common/io/mac/mac_ktest.c
+++ b/usr/src/uts/common/io/mac/mac_ktest.c
@@ -22,38 +22,56 @@
 #include <sys/dlpi.h>
 #include <sys/ethernet.h>
 #include <sys/ktest.h>
+#include <sys/mac_client.h>
 #include <sys/mac_provider.h>
 #include <sys/pattr.h>
+#include <sys/strsubr.h>
 #include <sys/strsun.h>
 
-typedef mblk_t *(*mac_sw_cksum_t)(mblk_t *, mac_emul_t);
-
 /* Arbitrary limits for cksum tests */
 #define	PADDING_MAX	32
 #define	SPLITS_MAX	8
 
-typedef struct cksum_test_params {
-	mblk_t		*ctp_mp;
-	uchar_t		*ctp_raw;
-	uint_t		ctp_raw_sz;
-	boolean_t	ctp_do_partial;
-	boolean_t	ctp_do_full;
-	boolean_t	ctp_do_ipv4;
-	uint_t		ctp_splits[SPLITS_MAX];
-} cksum_test_params_t;
+typedef struct emul_test_params {
+	mblk_t		*etp_mp;
+	uchar_t		*etp_raw;
+	uint_t		etp_raw_sz;
+	uchar_t		*etp_outputs;
+	uint_t		etp_outputs_sz;
+	boolean_t	etp_do_partial;
+	boolean_t	etp_do_full;
+	boolean_t	etp_do_ipv4;
+	boolean_t	etp_do_lso;
+	uint_t		etp_mss;
+	uint_t		etp_splits[SPLITS_MAX];
+} emul_test_params_t;
+
+static void
+etp_free(const emul_test_params_t *etp)
+{
+	if (etp->etp_mp != NULL) {
+		freemsgchain(etp->etp_mp);
+	}
+	if (etp->etp_raw != NULL) {
+		kmem_free(etp->etp_raw, etp->etp_raw_sz);
+	}
+	if (etp->etp_outputs != NULL) {
+		kmem_free(etp->etp_outputs, etp->etp_outputs_sz);
+	}
+}
 
 static mblk_t *
-cksum_alloc_pkt(const cksum_test_params_t *ctp, uint32_t padding)
+cksum_alloc_pkt(const emul_test_params_t *etp, uint32_t padding)
 {
-	uint32_t remain = ctp->ctp_raw_sz;
+	uint32_t remain = etp->etp_raw_sz;
 	uint_t split_idx = 0;
-	const uint8_t *pkt_bytes = ctp->ctp_raw;
+	const uint8_t *pkt_bytes = etp->etp_raw;
 
 	mblk_t *head = NULL, *tail = NULL;
 	while (remain > 0) {
-		const boolean_t has_split = ctp->ctp_splits[split_idx] != 0;
+		const boolean_t has_split = etp->etp_splits[split_idx] != 0;
 		const uint32_t to_copy = has_split ?
-		    MIN(remain, ctp->ctp_splits[split_idx]) : remain;
+		    MIN(remain, etp->etp_splits[split_idx]) : remain;
 		const uint32_t to_alloc = padding + to_copy;
 
 		mblk_t *mp = allocb(to_alloc, 0);
@@ -89,13 +107,13 @@ cksum_alloc_pkt(const cksum_test_params_t *ctp, uint32_t padding)
 }
 
 static boolean_t
-cksum_test_parse_input(ktest_ctx_hdl_t *ctx, cksum_test_params_t *ctp)
+emul_test_parse_input(ktest_ctx_hdl_t *ctx, emul_test_params_t *etp)
 {
 	uchar_t *bytes;
 	size_t num_bytes = 0;
 
 	ktest_get_input(ctx, &bytes, &num_bytes);
-	bzero(ctp, sizeof (*ctp));
+	bzero(etp, sizeof (*etp));
 
 	nvlist_t *params = NULL;
 	if (nvlist_unpack((char *)bytes, num_bytes, &params, KM_SLEEP) != 0) {
@@ -103,8 +121,8 @@ cksum_test_parse_input(ktest_ctx_hdl_t *ctx, cksum_test_params_t *ctp)
 		return (B_FALSE);
 	}
 
-	uchar_t *pkt_bytes;
-	uint_t pkt_sz;
+	uchar_t *pkt_bytes, *out_pkt_bytes;
+	uint_t pkt_sz, out_pkt_sz;
 
 	if (nvlist_lookup_byte_array(params, "pkt_bytes", &pkt_bytes,
 	    &pkt_sz) != 0) {
@@ -116,6 +134,19 @@ cksum_test_parse_input(ktest_ctx_hdl_t *ctx, cksum_test_params_t *ctp)
 		goto bail;
 	}
 
+	if (nvlist_lookup_byte_array(params, "out_pkt_bytes", &out_pkt_bytes,
+	    &out_pkt_sz) == 0) {
+		if (out_pkt_sz < sizeof (uint32_t)) {
+			KT_ERROR(ctx, "Serialized packets need a u32 length");
+			goto bail;
+		}
+		etp->etp_outputs = kmem_alloc(out_pkt_sz, KM_SLEEP);
+		bcopy(out_pkt_bytes, etp->etp_outputs, out_pkt_sz);
+		etp->etp_outputs_sz = out_pkt_sz;
+	}
+
+	(void) nvlist_lookup_uint32(params, "mss", &etp->etp_mss);
+
 	uint32_t padding = 0;
 	(void) nvlist_lookup_uint32(params, "padding", &padding);
 	if (padding & 1) {
@@ -126,9 +157,9 @@ cksum_test_parse_input(ktest_ctx_hdl_t *ctx, cksum_test_params_t *ctp)
 		goto bail;
 	}
 
-	ctp->ctp_do_ipv4 = fnvlist_lookup_boolean(params, "cksum_ipv4");
-	ctp->ctp_do_partial = fnvlist_lookup_boolean(params, "cksum_partial");
-	ctp->ctp_do_full = fnvlist_lookup_boolean(params, "cksum_full");
+	etp->etp_do_ipv4 = fnvlist_lookup_boolean(params, "cksum_ipv4");
+	etp->etp_do_partial = fnvlist_lookup_boolean(params, "cksum_partial");
+	etp->etp_do_full = fnvlist_lookup_boolean(params, "cksum_full");
 
 	uint32_t *splits;
 	uint_t nsplits;
@@ -146,21 +177,21 @@ cksum_test_parse_input(ktest_ctx_hdl_t *ctx, cksum_test_params_t *ctp)
 				KT_ERROR(ctx, "Splits must be 2-byte aligned");
 				goto bail;
 			}
-			ctp->ctp_splits[i] = splits[i];
+			etp->etp_splits[i] = splits[i];
 		}
 	}
 
-	if (ctp->ctp_do_partial && ctp->ctp_do_full) {
+	if (etp->etp_do_partial && etp->etp_do_full) {
 		KT_ERROR(ctx, "Cannot request full and partial cksum");
 		goto bail;
 	}
 
-	ctp->ctp_raw = kmem_alloc(pkt_sz, KM_SLEEP);
-	bcopy(pkt_bytes, ctp->ctp_raw, pkt_sz);
-	ctp->ctp_raw_sz = pkt_sz;
+	etp->etp_raw = kmem_alloc(pkt_sz, KM_SLEEP);
+	bcopy(pkt_bytes, etp->etp_raw, pkt_sz);
+	etp->etp_raw_sz = pkt_sz;
 
-	ctp->ctp_mp = cksum_alloc_pkt(ctp, padding);
-	if (ctp->ctp_mp == NULL) {
+	etp->etp_mp = cksum_alloc_pkt(etp, padding);
+	if (etp->etp_mp == NULL) {
 		KT_ERROR(ctx, "Could not allocate mblk");
 		goto bail;
 	}
@@ -169,9 +200,8 @@ cksum_test_parse_input(ktest_ctx_hdl_t *ctx, cksum_test_params_t *ctp)
 	return (B_TRUE);
 
 bail:
-	if (ctp->ctp_raw != NULL) {
-		kmem_free(ctp->ctp_raw, ctp->ctp_raw_sz);
-	}
+	etp_free(etp);
+
 	if (params != NULL) {
 		nvlist_free(params);
 	}
@@ -181,7 +211,7 @@ bail:
 /* Calculate pseudo-header checksum for a packet */
 static uint16_t
 cksum_calc_pseudo(ktest_ctx_hdl_t *ctx, const uint8_t *pkt_data,
-    const mac_ether_offload_info_t *meoi)
+    const mac_ether_offload_info_t *meoi, boolean_t exclude_len)
 {
 	if ((meoi->meoi_flags & MEOI_L4INFO_SET) == 0) {
 		KT_ERROR(ctx, "MEOI lacks L4 info");
@@ -234,7 +264,10 @@ cksum_calc_pseudo(ktest_ctx_hdl_t *ctx, const uint8_t *pkt_data,
 		ulp_len = ntohs(ipha->ipha_length) - meoi->meoi_l3hlen;
 	}
 
-	cksum += htons(ulp_len);
+	/* LSO packets omit ULP length from cksum since it may be changing */
+	if (!exclude_len) {
+		cksum += htons(ulp_len);
+	}
 
 	cksum = (cksum >> 16) + (cksum & 0xffff);
 	cksum = (cksum >> 16) + (cksum & 0xffff);
@@ -266,26 +299,26 @@ mblk_write16(mblk_t *mp, uint_t off, uint16_t val)
 	*datap = val;
 }
 
-/* Compare resulting mblk with known good value in test parameters.  */
+/* Compare an individual mblk with known good value in test parameters.  */
 static boolean_t
-cksum_result_compare(ktest_ctx_hdl_t *ctx, const cksum_test_params_t *ctp,
+pkt_compare(ktest_ctx_hdl_t *ctx, const uchar_t *buf, const uint_t len,
     mblk_t *mp)
 {
-	if (msgdsize(mp) != ctp->ctp_raw_sz) {
-		KT_FAIL(ctx, "mp size %u != %u", msgdsize(mp), ctp->ctp_raw_sz);
+	if (msgdsize(mp) != len) {
+		KT_FAIL(ctx, "mp size %u != %u", msgdsize(mp), len);
 		return (B_FALSE);
 	}
 
 	uint32_t fail_val = 0, good_val = 0;
 	uint_t mp_off = 0, fail_len = 0, i;
-	for (i = 0; i < ctp->ctp_raw_sz; i++) {
+	for (i = 0; i < len; i++) {
 		/*
 		 * If we encounter a mismatch, collect up to 4 bytes of context
 		 * to print with the failure.
 		 */
-		if (mp->b_rptr[mp_off] != ctp->ctp_raw[i] || fail_len != 0) {
+		if (mp->b_rptr[mp_off] != buf[i] || fail_len != 0) {
 			fail_val |= mp->b_rptr[mp_off] << (fail_len * 8);
-			good_val |= ctp->ctp_raw[i] << (fail_len * 8);
+			good_val |= buf[i] << (fail_len * 8);
 
 			fail_len++;
 			if (fail_len == 4) {
@@ -309,35 +342,59 @@ cksum_result_compare(ktest_ctx_hdl_t *ctx, const cksum_test_params_t *ctp,
 	return (B_TRUE);
 }
 
-/*
- * Verify mac_sw_cksum() emulation against an arbitrary input packet.  If the
- * packet is of a support protocol, any L3 and L4 checksums are cleared, and
- * then mac_sw_cksum() is called to perform the offload emulation.  Afterwards,
- * the packet is compared to see if it equasl the input, which is assumed to
- * have correct checksums.
- *
- * This can request either emulation via HCK_PARTIALCKSUM or HCK_FULLCKSUM.
- */
-static void
-mac_sw_cksum_test(ktest_ctx_hdl_t *ctx)
+/* Compare resulting mblk chain with known good values in test parameters. */
+static boolean_t
+pkt_result_compare_chain(ktest_ctx_hdl_t *ctx, const emul_test_params_t *etp,
+    mblk_t *mp)
 {
-	ddi_modhandle_t hdl = NULL;
-	mac_sw_cksum_t mac_sw_cksum = NULL;
+	uint_t remaining = etp->etp_outputs_sz;
+	const uchar_t *raw_cur = etp->etp_outputs;
+
+	uint_t idx = 0;
+	while (remaining != 0 && mp != NULL) {
+		uint32_t inner_pkt_len;
+		if (remaining < sizeof (inner_pkt_len)) {
+			KT_ERROR(ctx, "insufficient bytes to read packet len");
+			return (B_FALSE);
+		}
+		bcopy(raw_cur, &inner_pkt_len, sizeof (inner_pkt_len));
+		remaining -= sizeof (inner_pkt_len);
+		raw_cur += sizeof (inner_pkt_len);
 
-	if (ktest_hold_mod("mac", &hdl) != 0) {
-		KT_ERROR(ctx, "failed to hold 'mac' module");
-		return;
+		if (remaining < inner_pkt_len) {
+			KT_ERROR(ctx, "wanted %u bytes to read packet, had %u",
+			    inner_pkt_len, remaining);
+			return (B_FALSE);
+		}
+
+		if (!pkt_compare(ctx, raw_cur, inner_pkt_len, mp)) {
+			ktest_msg_prepend(ctx, "packet %u: ", idx);
+			return (B_FALSE);
+		}
+
+		remaining -= inner_pkt_len;
+		raw_cur += inner_pkt_len;
+		idx++;
+		mp = mp->b_next;
 	}
-	if (ktest_get_fn(hdl, "mac_sw_cksum", (void **)&mac_sw_cksum) != 0) {
-		KT_ERROR(ctx, "failed to resolve symbol mac`mac_sw_cksum");
-		goto cleanup;
+
+	if (remaining != 0) {
+		KT_FAIL(ctx, "fewer packets returned than expected");
+		return (B_FALSE);
 	}
 
-	cksum_test_params_t ctp;
-	if (!cksum_test_parse_input(ctx, &ctp)) {
-		goto cleanup;
+	if (mp != NULL) {
+		KT_FAIL(ctx, "more packets returned than expected");
+		return (B_FALSE);
 	}
-	mblk_t *mp = ctp.ctp_mp;
+
+	return (B_TRUE);
+}
+
+static void
+mac_hw_emul_test(ktest_ctx_hdl_t *ctx, emul_test_params_t *etp)
+{
+	mblk_t *mp = etp->etp_mp;
 
 	mac_ether_offload_info_t meoi;
 	mac_ether_offload_info(mp, &meoi);
@@ -346,19 +403,29 @@ mac_sw_cksum_test(ktest_ctx_hdl_t *ctx)
 	    (meoi.meoi_l3proto != ETHERTYPE_IP &&
 	    meoi.meoi_l3proto != ETHERTYPE_IPV6)) {
 		KT_SKIP(ctx, "l3 protocol not recognized/supported");
-		goto cleanup;
+		return;
 	}
 
 	mac_emul_t emul_flags = 0;
 	uint_t hck_flags = 0, hck_start = 0, hck_stuff = 0, hck_end = 0;
-	if (meoi.meoi_l3proto == ETHERTYPE_IP && ctp.ctp_do_ipv4) {
+
+	if (etp->etp_do_lso) {
+		emul_flags |= MAC_LSO_EMUL;
+		hck_flags |= HW_LSO;
+		if (etp->etp_mss == 0) {
+			KT_ERROR(ctx, "invalid MSS for LSO");
+			return;
+		}
+	}
+
+	if (meoi.meoi_l3proto == ETHERTYPE_IP && etp->etp_do_ipv4) {
 		mblk_write16(mp,
 		    meoi.meoi_l2hlen + offsetof(ipha_t, ipha_hdr_checksum), 0);
 		emul_flags |= MAC_IPCKSUM_EMUL;
 		hck_flags |= HCK_IPV4_HDRCKSUM;
 	}
 
-	const boolean_t do_l4 = ctp.ctp_do_partial || ctp.ctp_do_full;
+	const boolean_t do_l4 = etp->etp_do_partial || etp->etp_do_full;
 	if ((meoi.meoi_flags & MEOI_L4INFO_SET) != 0 && do_l4) {
 		boolean_t skip_pseudo = B_FALSE;
 		hck_start = meoi.meoi_l2hlen + meoi.meoi_l3hlen;
@@ -391,27 +458,28 @@ mac_sw_cksum_test(ktest_ctx_hdl_t *ctx)
 			 * account for its increased width.
 			 */
 			hck_stuff += SCTP_CHECKSUM_OFFSET;
-			if (ctp.ctp_do_full) {
+			if (etp->etp_do_full) {
 				mblk_write16(mp, hck_stuff, 0);
 				mblk_write16(mp, hck_stuff + 2, 0);
 			} else {
 				KT_SKIP(ctx,
 				    "Partial L4 cksum not supported for SCTP");
+				return;
 			}
 			break;
 		default:
 			KT_SKIP(ctx,
 			    "Partial L4 cksum not supported for proto");
-			goto cleanup;
+			return;
 		}
 
 		emul_flags |= MAC_HWCKSUM_EMUL;
-		if (ctp.ctp_do_partial) {
+		if (etp->etp_do_partial) {
 			hck_flags |= HCK_PARTIALCKSUM;
 			if (!skip_pseudo) {
 				/* Populate L4 pseudo-header cksum */
-				const uint16_t pcksum =
-				    cksum_calc_pseudo(ctx, ctp.ctp_raw, &meoi);
+				const uint16_t pcksum = cksum_calc_pseudo(ctx,
+				    etp->etp_raw, &meoi, etp->etp_do_lso);
 				mblk_write16(mp, hck_stuff, pcksum);
 			} else {
 				mblk_write16(mp, hck_stuff, 0);
@@ -424,7 +492,7 @@ mac_sw_cksum_test(ktest_ctx_hdl_t *ctx)
 	}
 	if (do_l4 && (hck_flags & (HCK_FULLCKSUM|HCK_PARTIALCKSUM)) == 0) {
 		KT_SKIP(ctx, "L4 checksum not supported for packet");
-		goto cleanup;
+		return;
 	}
 
 	if (emul_flags != 0) {
@@ -443,31 +511,80 @@ mac_sw_cksum_test(ktest_ctx_hdl_t *ctx)
 		/* Set hcksum information on all mblks in chain */
 		for (mblk_t *cmp = mp; cmp != NULL; cmp = cmp->b_cont) {
 			mac_hcksum_set(cmp, hck_start, hck_stuff, hck_end, 0,
-			    hck_flags);
+			    hck_flags & HCK_FLAGS);
+			lso_info_set(cmp, etp->etp_mss,
+			    hck_flags & HW_LSO_FLAGS);
 		}
-		ctp.ctp_mp = mp = mac_sw_cksum(mp, emul_flags);
 
-		KT_ASSERT3UG(mp, !=, NULL, ctx, cleanup);
-		if (!cksum_result_compare(ctx, &ctp, mp)) {
-			goto cleanup;
+		mac_hw_emul(&mp, NULL, NULL, emul_flags);
+		KT_ASSERT3P(mp, !=, NULL, ctx);
+		etp->etp_mp = mp;
+
+		boolean_t success = (etp->etp_outputs == NULL) ?
+		    pkt_compare(ctx, etp->etp_raw, etp->etp_raw_sz, mp) :
+		    pkt_result_compare_chain(ctx, etp, mp);
+		if (!success) {
+			return;
 		}
 	} else {
-		KT_SKIP(ctx, "no checksums supported for packet");
-		goto cleanup;
+		KT_SKIP(ctx, "offloads unsupported for packet");
+		return;
 	}
 
 	KT_PASS(ctx);
+}
+
+/*
+ * Verify checksum emulation against an arbitrary chain of packets.  If the
+ * packet is of a supported protocol, any L3 and L4 checksums are cleared, and
+ * then mac_hw_emul() is called to perform the offload emulation.  Afterwards,
+ * the packet is compared to see if it equals the input, which is assumed to
+ * have correct checksums.
+ */
+static void
+mac_sw_cksum_test(ktest_ctx_hdl_t *ctx)
+{
+	emul_test_params_t etp;
+	if (!emul_test_parse_input(ctx, &etp)) {
+		goto cleanup;
+	}
+
+	mac_hw_emul_test(ctx, &etp);
 
 cleanup:
-	if (hdl != NULL) {
-		ktest_release_mod(hdl);
+	etp_free(&etp);
+}
+
+/*
+ * Verify mac_sw_lso() (and checksum) emulation against an arbitrary input
+ * packet.  This test functions like mac_sw_cksum_test insofar as checksums can
+ * be customised, but also sets HW_LSO on any input packet, and compares the
+ * outputs against a mandatory chain of packets provided by the caller.
+ */
+static void
+mac_sw_lso_test(ktest_ctx_hdl_t *ctx)
+{
+	emul_test_params_t etp;
+	if (!emul_test_parse_input(ctx, &etp)) {
+		goto cleanup;
 	}
-	if (ctp.ctp_mp != NULL) {
-		freemsg(ctp.ctp_mp);
+
+	if (etp.etp_mss == 0) {
+		KT_ERROR(ctx, "invalid MSS for LSO");
+		goto cleanup;
 	}
-	if (ctp.ctp_raw != NULL) {
-		kmem_free(ctp.ctp_raw, ctp.ctp_raw_sz);
+
+	if (etp.etp_outputs == NULL) {
+		KT_ERROR(ctx, "LSO tests require explicit packet list");
+		goto cleanup;
 	}
+
+	etp.etp_do_lso = B_TRUE;
+
+	mac_hw_emul_test(ctx, &etp);
+
+cleanup:
+	etp_free(&etp);
 }
 
 typedef struct meoi_test_params {
@@ -790,6 +907,11 @@ _init()
 	VERIFY0(ktest_add_test(ks, "mac_sw_cksum_test",
 	    mac_sw_cksum_test, KTEST_FLAG_INPUT));
 
+	ks = NULL;
+	VERIFY0(ktest_add_suite(km, "lso", &ks));
+	VERIFY0(ktest_add_test(ks, "mac_sw_lso_test",
+	    mac_sw_lso_test, KTEST_FLAG_INPUT));
+
 	ks = NULL;
 	VERIFY0(ktest_add_suite(km, "parsing", &ks));
 	VERIFY0(ktest_add_test(ks, "mac_ether_offload_info_test",
